/**
 * A class that implements the MyMap interface using a hash map/table
 * data structure.
 *
 * @author <your name here>
 * @version 1.0
 */
public class MyHashMap<K,V> implements MyMap<K,V> {
    // number of items in the hash table
    private int nentries = 0;

    // initial number of buckets
    private int nbuckets = 10;

    // the threshold above which the hashtable will be resized
    static final double RESIZE_THRESHOLD = 0.75; // package private to allow testing

    // the actual hash table which is an array of linked lists
    // each linked list is a list of key value pairs
    // private MyList<???>[] table;

    /**
     * Constructor for objects of class MyHashMap.
     * Should create an empty map.
     * 
     */
    public MyHashMap() {
        // TODO implement
    }

    /**
     * Associates a value with a key.
     * If adding this new (key, value) pair makes the load factor cross
     * the resize threshold, the number of buckets should be doubled and
     * all entries rehashed.
     *
     * @param k key
     * @param v value
     * @return if key was already associated with a value return
     * it, otherwise null.
     */
    public V put(K key, V value) {
        // TODO implement
        return null;
    }

    /**
     *  Retrieves a value associated with a key. 
     *  @param k key
     *  @return the value associated with that key, null if 
     *  key not present in the map.
     */
    public V get(K key) {
        // TODO implement
        return null;
    }

    /**
     * Removes mapping associated with that key.
     * @param k key
     * @return the value associated with that key, or null if none
     */
    public V remove(K key) {
        // TODO implement
        return null;
    }

    /**
     * Returns the number of key value pairs in the map.
     * @return number of key value pairs
     */
    public int size() {
        // TODO implement
        return Integer.MIN_VALUE;
    }

    /**
     * Returns the map's current load factor, which is defined as the ratio between
     * the number of map entries and the number of buckets.
     * It is package private so we can use it in our unit test class.
     * 
     * @ return the hash map's current load factor.
     */
    double loadFactor(){
        return ((double) this.nentries) / this.nbuckets;
    }
}
